# File: BannerAdmin.py
#
# Copyright (c) 2006 by Kombinat Media Gestalter GmbH
# Generator: ArchGenXML Version 1.4.1 svn/devel
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Mag. Peter Mathis <peter.mathis@kombinat.at>"""
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *




from Products.KBannerAd.config import *

from Products.CMFCore.utils import UniqueObject

    
##code-section module-header #fill in your manual code here
##/code-section module-header

schema = Schema((

),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

BannerAdmin_schema = BaseFolderSchema.copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class BannerAdmin(UniqueObject,BaseFolder):
    security = ClassSecurityInfo()
    __implements__ = (getattr(UniqueObject,'__implements__',()),) + (getattr(BaseFolder,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name = 'BannerAdmin'

    meta_type = 'BannerAdmin'
    portal_type = 'BannerAdmin'
    allowed_content_types = ['Banner']
    filter_content_types = 1
    global_allow = 0
    allow_discussion = False
    content_icon = 'KBannerAd.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "BannerAdmin"
    typeDescMsgId = 'description_edit_banneradmin'

    actions =  (


       {'action': "string:${object_url}/banner_list",
        'category': "object",
        'id': 'view',
        'name': 'banner_list',
        'permissions': ("View",),
        'condition': 'python:1'
       },


    )
    toolicon = 'KBannerAd.gif'

    schema = BannerAdmin_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    # tool-constructors have no id argument, the id is fixed
    def __init__(self, id=None):
        BaseFolder.__init__(self,'portal_banneradmin')
        
        ##code-section constructor-footer #fill in your manual code here
        ##/code-section constructor-footer



    # Methods
    security.declarePublic('banner_click')
    def banner_click(self, UID=None):
        """
        gets the UID of the banner, saves the click and redirects to the URL
        """
        if not UID:
          return
          
        atool = self.archetype_tool
        cat = self.portal_catalog
        banner = atool.lookupObject(UID)
        intLink = banner.getLinkIntern()
        extLink = banner.getLinkExtern()
        link = (intLink and intLink.absolute_url()) or extLink
        
        # save click
        banner.setClicksUsed((banner.getClicksUsed() or 0) + 1)
        
        # update catalog entries (metadata getClicks and getClicksUsed)
        cat.reindexObject(banner)
        
        # redirect to the URL
        self.REQUEST.RESPONSE.redirect(link)

    security.declarePublic('bulk_edit_banners')
    def bulk_edit_banners(self, REQUEST=None):
        """
        edit all fields from template banner_list
        """
        if not REQUEST:
          REQUEST = self.REQUEST
        
        ids = REQUEST.get('banner-ids')
        
        for id in ids:
          editVals = {'clicks': REQUEST.get('clicks_%s' % id),
                      'percent':REQUEST.get('percent_%s' % id),
                     }
          banner = getattr(self,id)
          banner.edit(**editVals)
         
        return self.banner_list()
    
def modify_fti(fti):
    # Hide unnecessary tabs (usability enhancement)
    for a in fti['actions']:
        if a['id'] in ['edit', 'sharing', 'metadata', 'folderlisting']:
            a['visible'] = 0
    return fti

registerType(BannerAdmin,PROJECTNAME)
# end of class BannerAdmin

##code-section module-footer #fill in your manual code here
##/code-section module-footer



