# File: Banner.py
#
# Copyright (c) 2006 by Kombinat Media Gestalter GmbH
# Generator: ArchGenXML Version 1.4.1 svn/devel
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Mag. Peter Mathis <peter.mathis@kombinat.at>"""
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *




# additional imports from tagged value 'import'
from Products.ATReferenceBrowserWidget.ATReferenceBrowserWidget import ReferenceBrowserWidget

from Products.KBannerAd.config import *
##code-section module-header #fill in your manual code here
##/code-section module-header

copied_fields = {}
copied_fields['effectiveDate'] = BaseSchema['effectiveDate'].copy()
copied_fields['effectiveDate'].schemata = "default"
copied_fields['effectiveDate'].widget.label_msgid = "KBannerAd_label_effective"
copied_fields['expirationDate'] = BaseSchema['expirationDate'].copy()
copied_fields['expirationDate'].schemata = "default"
copied_fields['expirationDate'].widget.label_msgid = "KBannerAd_label_expired"
schema = Schema((

    FileField(
        name='source',
        widget=FileWidget(
            description="bilder oder flash",
            label='Source',
            label_msgid='KBannerAd_label_source',
            description_msgid='KBannerAd_help_source',
            i18n_domain='KBannerAd',
        ),
        required=1,
        storage=AttributeStorage()
    ),

    IntegerField(
        name='clicks',
        widget=IntegerWidget(
            label='Clicks',
            label_msgid='KBannerAd_label_clicks',
            i18n_domain='KBannerAd',
        ),
        required=1
    ),

    IntegerField(
        name='clicksUsed',
        default="0",
        widget=IntegerWidget(
            visible=-1,
            label='Clicksused',
            label_msgid='KBannerAd_label_clicksUsed',
            i18n_domain='KBannerAd',
        )
    ),

    IntegerField(
        name='percent',
        widget=IntegerWidget(
            label='Percent',
            label_msgid='KBannerAd_label_percent',
            i18n_domain='KBannerAd',
        ),
        required=1
    ),

    StringField(
        name='viewMacro',
        widget=SelectionWidget
        (
            format="select",
            label='Viewmacro',
            label_msgid='KBannerAd_label_viewMacro',
            i18n_domain='KBannerAd',
        ),
        vocabulary='getPortletMacros'
    ),

    ReferenceField(
        name='linkIntern',
        widget=ReferenceBrowserWidget
        (
            allowed_types=('RichDocument', 'File', 'Image', 'Folder'),
            label='Linkintern',
            label_msgid='KBannerAd_label_linkIntern',
            i18n_domain='KBannerAd',
        ),
        multiValued=0,
        relationship="banner_int_link"
    ),

    StringField(
        name='linkExtern',
        widget=StringWidget(
            label='Linkextern',
            label_msgid='KBannerAd_label_linkExtern',
            i18n_domain='KBannerAd',
        ),
        validators=('isURL',)
    ),

    copied_fields['effectiveDate'],
    
    copied_fields['expirationDate'],
    
),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

Banner_schema = BaseSchema.copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class Banner(BaseContent):
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name = 'Banner'

    meta_type = 'Banner'
    portal_type = 'Banner'
    allowed_content_types = []
    filter_content_types = 0
    global_allow = 1
    allow_discussion = False
    content_icon = 'KBannerAd.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "Banner"
    typeDescMsgId = 'description_edit_banner'

    _at_rename_after_creation = True

    schema = Banner_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    # Methods
    security.declarePrivate('getPortletMacros')
    def getPortletMacros(self):
        """
        
        """
        portlet_banner = getattr(self,'portlet_banner')
        
        if portlet_banner:
          return tuple(portlet_banner.macros)
          
        pass


registerType(Banner,PROJECTNAME)
# end of class Banner

##code-section module-footer #fill in your manual code here
##/code-section module-footer



